
################################################################
## copyright 2003 Compaq Information Technologies Group, L.P. ##
################################################################

#Redhat 8.0

CC=gcc

EFS_VER=$(shell if [ -f PKG_VERSION ]; then cat PKG_VERSION; else echo Dangerous; fi)

# LINUX_KERN_DIR=$(shell uname -r)
LINUX_KERN_DIR=$(shell uname -r | sed -e 's/enterprise//g' -e 's/smp//g' -e 's/bigmem//g')
OS_VERSION_UP=$(LINUX_KERN_DIR)
OS_VERSION_MP=$(LINUX_KERN_DIR)smp
OS_VERSION_EP=$(LINUX_KERN_DIR)enterprise
OS_VERSION_BM=$(LINUX_KERN_DIR)bigmem

OS_MODEL=LINUX

IFLAGS=-I./ -I/lib/modules/`uname -r`/build/include

DFLAGS=-D__KERNEL__ -DMODULE -DEFS_VER=\"$(EFS_VER)\"

INCLUDE= -I./
LINUX_INCLUDE_UP = -I/lib/modules/$(OS_VERSION_UP)/build/include/
LINUX_INCLUDE_MP = -I/lib/modules/$(OS_VERSION_MP)/build/include/
LINUX_INCLUDE_EP = -I/lib/modules/$(OS_VERSION_EP)/build/include/
LINUX_INCLUDE_BM = -I/lib/modules/$(OS_VERSION_BM)/build/include/

LINUX_HEADERS_UP = -D__BOOT_KERNEL_H_ -D__MODULE_KERNEL_i686=1 -D__BOOT_KERNEL_ENTERPRISE=0 -D__BOOT_KERNEL_SMP=0 -D__BOOT_KERNEL_UP=1 -D__BOOT_KERNEL_BIGMEM=0
LINUX_HEADERS_MP = -D__BOOT_KERNEL_H_ -D__MODULE_KERNEL_i686=1 -D__BOOT_KERNEL_ENTERPRISE=0 -D__BOOT_KERNEL_SMP=1 -D__BOOT_KERNEL_UP=0 -D__BOOT_KERNEL_BIGMEM=0
LINUX_HEADERS_EP = -D__BOOT_KERNEL_H_ -D__MODULE_KERNEL_i686=1 -D__BOOT_KERNEL_ENTERPRISE=1 -D__BOOT_KERNEL_SMP=0 -D__BOOT_KERNEL_UP=0 -D__BOOT_KERNEL_BIGMEM=0
LINUX_HEADERS_BM = -D__BOOT_KERNEL_H_ -D__MODULE_KERNEL_i686=1 -D__BOOT_KERNEL_ENTERPRISE=0 -D__BOOT_KERNEL_SMP=0 -D__BOOT_KERNEL_UP=0 -D__BOOT_KERNEL_BIGMEM=1

CFLAGS_UP = -O2 $(DFLAGS) $(LINUX_HEADERS_UP) $(LINUX_INCLUDE_UP) $(INCLUDE)
CFLAGS_MP = -O2 $(DFLAGS) $(LINUX_HEADERS_MP) $(LINUX_INCLUDE_MP) $(INCLUDE)
CFLAGS_EP = -O2 $(DFLAGS) $(LINUX_HEADERS_EP) $(LINUX_INCLUDE_EP) $(INCLUDE)
CFLAGS_BM = -O2 $(DFLAGS) $(LINUX_HEADERS_BM) $(LINUX_INCLUDE_BM) $(INCLUDE)

all:	clean cmhp.c cmhp_up.o cmhp_smp.o cmhp_bm.o

rebuild: clean
	$(CC) $(DFLAGS) $(IFLAGS) -c cmhp.c
	ld -r -o cmhp_custom.o cmhp.o cmhp_lib.o

cmhp_up.o:
	$(CC) $(CFLAGS_UP) -c cmhp.c -o cmhp.o
	$(LD) -x -r -o cmhp_up.o cmhp.o cmhp_lib.o

cmhp_smp.o:
	$(CC) $(CFLAGS_MP) -c cmhp.c -o cmhp.o
	$(LD) -x -r -o cmhp_smp.o cmhp.o cmhp_lib.o

cmhp_bm.o:
	$(CC) $(CFLAGS_BM) -c cmhp.c -o cmhp.o
	$(LD) -x -r -o cmhp_bm.o cmhp.o cmhp_lib.o

clean:
	rm -f cmhp_custom.o cmhp.o cmhp_up.o cmhp_smp.o cmhp_bm.o
