/***************************************************************************
*         Copyright 2002 Compaq Information Technologies Group, L.P.       *
****************************************************************************
*
*  @doc
*
*  @module  oswrap.h
*  Version: 1.0
*
*  Function: This include determines which OS wrapper file to include
*            for the module.  This also provides the "must have" function
*            definition.  These functions must be defined and declared
*            by the wrapper code inorder for the common code to work.
*
*  @doc
****************************************************************************
*
*  @doc
*
*  Change Log:
*
*       Date    Who   Description
*
*****************************************************************************/

#ifndef INCL_OSWRAP_H
#define INCL_OSWRAP_H

#ifdef UW700
#include "casmw_uw700.h"
#endif

#ifdef LINUX
#include "unixincl.h"
#include "convert.h"

//*************************************************************************
//  Constants
//*************************************************************************

#define CASM_NMI_UNKNOWN       0
#define CASM_NMI_BENIGN        1
#define CASM_NMI_FATAL         2
#define CASM_NMI_REBOOT        3

#endif

#ifdef SCO500
#include "casmw_sco500.h"
#endif

#endif

