#!/bin/sh
#
# **************************************************************************
#  copyright 2002 Compaq Information Technologies Group, L.P.
#  Hewlett-Packard Company Confidential
# **************************************************************************
#
#  This is a sample script to demonstrate how to use the "hpuid" utility.
#  See the cpqhealth(4) man page for details.
# **************************************************************************

if [ -z $1 ]
then
	echo "USAGE:  hpuid_example [ON | OFF | STATUS]"
   exit 1
fi

if [ $1 == "ON" ]
then
	/sbin/hpuid -e
        ERROR=$?
	if [ $ERROR -ne 0 ]
	then
		echo "ERROR Returned:  $ERROR"
	fi
fi


if [ $1 == "OFF" ]
then
	/sbin/hpuid -d
        ERROR=$?
	if [ $ERROR -ne 0 ]
	then
		echo "ERROR Returned:  $ERROR"
	fi
fi


if [ $1 == "STATUS" ]
then
	STATUS=`/sbin/hpuid -s`
        ERROR=$?
	if [ $ERROR -ne 0 ]
	then
		echo "ERROR Returned:  $ERROR"
	fi

	echo "The current status is:  $STATUS"
fi
