<!-- $Id: objtable.tpl,v 1.1.1.1 2003/01/30 16:38:07 cschmitz Exp $ -->
<!-- Copyright 2002 Compaq Information Technologies Group, L.P. -->

<SCRIPT LANGUAGE='JavaScript'>


<!#/COMMON/TABLES.JS>

function wtHeadString()
{
   var hs="";

   if( null!=this.title && ""!=this.title )
   {
      hs = tableLabel( this.title, this.helpText ) + "\n";
   }

   hs += tblHead;

   return hs;
}


function wtTailString()
{
   return tblTail;
}


function wtBodyString()
{
   var bs="";
   var col;
   var thisRow;
   var row;

   for(row=0; row<this.rowData.length; row++)
   {
      thisRow = this.rowData[row];

      bs += "<tr>";
      for(col=0; col<this.columns; col++)
      {
         bs += "<td>" + (col < thisRow.length ? thisRow[col] : "&#160") + "</td>";
      }
      bs += "</tr>\n";
   }

   return bs;
}


function wtToString()
{
   return this.headString() + this.bodyString() + this.tailString();
}


function wtAddRow()
{
   var arglen = wtAddRow.arguments.length;
   var i;
   var j = this.rowData.length;

   if( arglen>this.columns )
   {
      this.columns = arglen;
   }

   this.rowData[j] = new Array;

   for(i=0; i<arglen; i++)
   {
      this.rowData[j][i] = wtAddRow.arguments[i];
   }
}


function wtRows()
{
   return this.rows;
}


function webemTableConstructor( argarray )
{
   var numargs = argarray.length;

   // object data
   this.title = argarray[0];
   this.tableHelp = 1 <= numargs ? argarray[1] : null;
   this.columns = 0;

   this.rowData = new Array;

   // object member functions
   this.headString = wtHeadString;
   this.bodyString = wtBodyString;
   this.tailString = wtTailString;
   this.toString = wtToString;

   this.addRow = wtAddRow;
   this.rows = wtRows;
}


function webemTableInitialize( argarray )
{
   var numargs = argarray.length;
   var i, j, numrows, argindex;

   // object data
   this.columns =  2 <= numargs ? argarray[2] : 0;

   if(3<numargs && 0<this.columns)
   {
      numrows = parseInt( (numargs-3)/this.columns + ( (numargs-3)%this.columns ? 1 : 0 ) );

      for(i=0; i<numrows; i++)
      {
         this.rowData[i] = new Array;
         for(j=0; j<this.columns; j++)
         {
            argindex = 3 + j + i*this.columns;
            this.rowData[i][j] =  argindex < numargs ? argarray[argindex] : "&#160";
         }
      }
   }
}


function webemTable( title, helpText )
{
   this.superConstructor = webemTableConstructor;
   this.superConstructor( webemTable.arguments );

   this.init = webemTableInitialize;
   this.init( webemTable.arguments );
}


function wstBodyString()
{
   var bs = "";
   var oneitemfn  = oneItemTableRow;
   var twoitemfn  = singleTableRow;
   var fouritemfn = doubleTableRow;
   var thisRow, i;

   if( 2==this.columns)
   {
      oneitemfn = oneItemTableRowInSingleTable;
   }
   else if (2 < this.columns)
   {
      oneitemfn = oneItemTableRowInDoubleTable;
      twoitemfn = singleTableRowInDoubleTable;
   }

   for(i=0; i<this.rowData.length; i++)
   {
      thisRow = this.rowData[i];

      if( 0==thisRow.length )
      {
         bs += oneitemfn( "" );
      }
      else if( 1==thisRow.length )
      {
         bs += oneitemfn( thisRow[0] );
      }
      else if ( 2==thisRow.length )
      {
         bs += twoitemfn( thisRow[0], thisRow[1] );
      }
      else if (thisRow.length)
      {
         bs += fouritemfn( thisRow[0], thisRow[1], thisRow[2], thisRow[3] );
      }
   }

   return bs;
}


function webemStandardTable( tableTitle, helpText )
{
   this.superConstructor = webemTableConstructor;
   this.superConstructor( webemStandardTable.arguments );

   this.bodyString = wstBodyString;

   this.init = webemTableInitialize;
   this.init( webemStandardTable.arguments );
}


function wctBodyString()
{
   var bs = "";
   var row;

   if(0<this.rowData.length)
   {

      bs = simpleTableRow( this.rowData[0], this.columns, "B" );

      for(row=1; row<this.rowData.length; row++)
      {
         bs += simpleTableRow(this.rowData[row], this.columns);
      }
   }

   return bs;
}


function webemColumnTable( tableTitle, helpText )
{
   this.superConstructor = webemTableConstructor;
   this.superConstructor( webemColumnTable.arguments );

   this.bodyString = wctBodyString;

   this.init = webemTableInitialize;
   this.init( webemColumnTable.arguments );
}


</SCRIPT>
